package com.tashow.cloud.product.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tashow.cloud.product.dto.ProdPropDO;
import com.tashow.cloud.product.mapper.ProdPropMapper;
import com.tashow.cloud.product.mapper.ProdPropValueMapper;
import com.tashow.cloud.product.service.ProdPropService;
import com.tashow.cloud.product.vo.prodprop.ProdPropPageReqVO;
import com.tashow.cloud.product.vo.prodprop.ProdPropSaveReqVO;
import com.tashow.cloud.productapi.enums.ErrorCodeConstants;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.tashow.cloud.common.pojo.PageResult;
import com.tashow.cloud.common.pojo.PageParam;
import com.tashow.cloud.common.util.object.BeanUtils;


import static com.tashow.cloud.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 商品属性 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class ProdPropServiceImpl extends ServiceImpl<ProdPropMapper, ProdPropDO>  implements ProdPropService {

    @Resource
    private ProdPropMapper prodPropMapper;
    @Resource
    private ProdPropValueMapper prodPropValueMapper;

    @Override
    public Long createProdProp(ProdPropSaveReqVO createReqVO) {
        // 插入
        ProdPropDO prodProp = BeanUtils.toBean(createReqVO, ProdPropDO.class);
        prodPropMapper.insert(prodProp);
        // 返回
        return prodProp.getPropId();
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveProdPropAndValues(ProdPropSaveReqVO createReqVO) {
        if(createReqVO.getShopId()==null){
            createReqVO.setShopId(1L);
        }
        ProdPropDO dbProdProp = prodPropMapper.getProdPropByPropNameAndShopId(createReqVO.getPropName(), createReqVO.getShopId(), createReqVO.getRule());
        if (dbProdProp != null) {
            throw new RuntimeException("已有相同名称规格");
        }
        ProdPropDO prodProp = BeanUtils.toBean(createReqVO, ProdPropDO.class);
        prodPropMapper.insert(prodProp);
        if (CollUtil.isEmpty(createReqVO.getProdPropValues())) {
            return;
        }
        prodPropValueMapper.insertPropValues(prodProp.getPropId(), createReqVO.getProdPropValues());
    }


    @Override
    public void updateProdProp(ProdPropSaveReqVO updateReqVO) {
        // 校验存在
        validateProdPropExists(updateReqVO.getPropId());
        // 更新
        ProdPropDO updateObj = BeanUtils.toBean(updateReqVO, ProdPropDO.class);
        prodPropMapper.updateById(updateObj);
    }

    @Override
    public void deleteProdProp(Long id) {
        // 校验存在
        validateProdPropExists(id);
        // 删除
        prodPropMapper.deleteById(id);
    }

    private void validateProdPropExists(Long id) {
        if (prodPropMapper.selectById(id) == null) {
            throw exception(ErrorCodeConstants.PROD_PROP_NOT_EXISTS);
        }
    }

    @Override
    public ProdPropDO getProdProp(Long id) {
        return prodPropMapper.selectById(id);
    }

    @Override
    public PageResult<ProdPropDO> getProdPropPage(ProdPropPageReqVO pageReqVO) {
        return null;
    }

}